extends TextureRect

class_name BlurCapture

export(bool) var enable_blur = true
export(bool) var always_use_root = false
export(Color) var tint = Color(0.8,0.8,0.8,1.0)

func _ready():
	init_properties()
	connect("visibility_changed",self,"visibility_changed")

#func set_visible(value):
#	if value:
#		call_deferred("set_blur_texture")
#	.set_visible(value)

func init_properties():
	stretch_mode = TextureRect.STRETCH_KEEP_ASPECT_COVERED
	flip_v = true
	#self_modulate = Color.webgray
	self_modulate = tint

func visibility_changed():
	var visibility = true if is_visible_in_tree() else false
	if visibility:
		call_deferred("set_blur_texture")
	else:
		texture = null
	#print("Visibility changed on %s -> visibility is %s" %[name,visibility])

func set_blur_texture():
	#print("Color is %s, %s" %[modulate,self_modulate])
	#texture = null
	var SBlur = ScaledBlur.new()
	var draw_view = get_tree().root
	var Subview = get_tree().get_nodes_in_group("Subview")
	if Subview.size() > 0 and not always_use_root:
		draw_view = Subview[0]
	var img:Image = draw_view.get_texture().get_data()
	if enable_blur:
		SBlur.connect("blur_finished",self,"update_blur_image")
		SBlur.blur_image_threaded(img,2,3,3)
	else:
		update_blur_image(img)
	

func update_blur_image(img):
	var ImgTexture = ImageTexture.new()
	ImgTexture.create_from_image(img)
	texture = ImgTexture


