extends Camera2D

class_name Camera2DAspectCovered

onready var Tweener = null if not has_node("Tween") else get_node("Tween")

func _ready():
	cover_aspect()

func cover_aspect():
	var ref_size = Func.get_reference_size()
	var monitor_size = Options.fullscreen_size
	print("----- %s aspect is %s" %[ref_size, ref_size.aspect()])
	print("----- %s aspect is %s" %[monitor_size, monitor_size.aspect()])
	#var zoom_point = monitor_size.aspect() / ref_size.aspect()
	var zoom_point = 1
	print("-----> Zoom point is %s" %zoom_point)
	zoom = Vector2(zoom_point,zoom_point)
	

func shake():
	if Tweener == null:
		return
	Tweener.interpolate_method(self,"random_offset",0,1,0.5,Tween.TRANS_LINEAR,Tween.EASE_IN)
	Tweener.interpolate_callback(self,0.51,"reset_offset")
	Tweener.start()

func flash(param):
	var color = param[0]
	var VNRender = get_tree().get_nodes_in_group("VNRender")
	if not VNRender.empty():
		VNRender = VNRender[0]
		if Tweener == null:
			return
		Tweener.interpolate_property(VNRender,"self_modulate",Color.white,color,0.4,Tween.TRANS_ELASTIC)
		Tweener.interpolate_property(VNRender,"self_modulate",color,Color.white,0.3,Tween.TRANS_ELASTIC,Tween.EASE_IN,0.4)
		Tweener.start()
		#Tweener.interpolate_property("self_modulate")

func random_offset(tick):
	var power = 0.5 * tick * randf()
	offset_h = rand_range(-power,power)
	offset_v = rand_range(-power,power)

func reset_offset():
	offset_h = 0
	offset_v = 0
