extends Node

class_name CGViewer

export(NodePath) var CGContainerPath
export(NodePath) var AnimatorPath

var CurrentCG:VNCG

onready var Animator = get_node_or_null(AnimatorPath)
onready var CGContainer = get_node_or_null(CGContainerPath)

signal cg_closed

func _ready():
	set_process_input(false)

func advance_cg():
	CurrentCG.advance()

func show_cg(index):
	var CGIns = VNAssets.CGData[index].data["scene"].instance()
	CGContainer.add_child(CGIns)
	CurrentCG = CGIns
	CurrentCG.connect("ended",self,"hide_cg")
	Animator.play("show")
	yield(Animator,"animation_finished")
	set_process_input(true)

func hide_cg():
	Audio.play_sfx("ui_back")
	set_process_input(false)
	Animator.play("hide")
	yield(Animator,"animation_finished")
	if CurrentCG != null:
		CurrentCG.queue_free()
	emit_signal("cg_closed")

func _input(_event):
	if Input.is_action_just_pressed("ui_cancel"):
		hide_cg()
	if OS.has_touchscreen_ui_hint():
		if _event is InputEventScreenTouch:
			if _event.pressed:
				advance_cg()
