extends Reference

class_name Chapters

var ChapterData:DictionaryData = null
var DialogData = {}
var OneTimeEffects = []

func _init():
	var chapter_dpath = ProjectSettings.get_setting("vn/gameplay/data/chapters")
	ChapterData = load(chapter_dpath)
	
	for key in ChapterData.data.keys():
		DialogData[key] = load(ChapterData.data[key].data_path)
	
	var VFXDir:Directory = Directory.new()
	var vfx_dir = "res://Objects/VN/Effects/"
	if VFXDir.open(vfx_dir) == OK:
		VFXDir.list_dir_begin(true)
		var file_name = VFXDir.get_next()
		while file_name != "":
			var vfx_path = vfx_dir.plus_file(file_name)
			var vfx_name = vfx_path.get_basename().get_file()
			var TempNode = load(vfx_path).instance()
			if TempNode.one_time:
				OneTimeEffects.append(vfx_name)
			TempNode.free()
			file_name = VFXDir.get_next()

func get_prev_effects(current_id,lookup_range):
	var pref_effects = {}
	var lookup_index = 0
	var c_dialog_id = int(lookup_range[lookup_index].x)
	var ch_id = get_chapter_id(c_dialog_id)
	var ch_range = get_chapter_range(ch_id)
	
	#while (c_dialog_id != SaveData.data.dialog):
	while (c_dialog_id != current_id):
		var i = int(c_dialog_id - ch_range.x)
		
		if DialogData[ch_id].data.has(i):
			if DialogData[ch_id].data[i].has("effects"):
				#var current_effects = DialogData[ch_id].data[i].effects
				var current_effects = DialogData[ch_id].data[i].effects.duplicate(true)
				for key in current_effects.keys():
					if key == "name":
						continue
					match key:
						"cg":
							if typeof(current_effects[key]) != TYPE_BOOL:
								pref_effects[key] = current_effects[key]
							else:
								if current_effects[key]:
									# for advancing cg, animating and such
									pass
								else:
									pref_effects.erase(key)
						"vfx":
							var converted_val = convert_effect_dic(current_effects[key],true)
							#print("Prev effect test vfx.. current_id = %s, i = %s" %[current_id,i+int(ch_range.x)])
							# for every record of this readed vfx
							for v_id in converted_val.keys():
								var cur_v = converted_val[v_id]
								var e_name = cur_v[0]
								# if this is not one time vfx, like prop and such
								if not OneTimeEffects.has(e_name):
									if pref_effects.has(key):
										# if previous effect already have vfx record
										var added = false
										for p_val_idx in pref_effects[key].size():
											# for every record of vfx that already have readed
											if pref_effects[key][p_val_idx][0] == e_name:
												# if the this vfx in readed is the same as this current new record
												for param in cur_v[1].keys():
													# for every parameters in this current new record
													match param:
														"action":
															match cur_v[1]["action"]:
																"advance":
																	if pref_effects[key][p_val_idx][1].has("action"):
																		if pref_effects[key][p_val_idx][1]["action"] == "advance":
																			if pref_effects[key][p_val_idx][1].has("value"):
																				pref_effects[key][p_val_idx][1]["value"] += 1
																			else:
																				pref_effects[key][p_val_idx][1]["value"] = 2
																		else:
																			pref_effects[key][p_val_idx][1]["action"] = "advance"
																			if pref_effects[key][p_val_idx][1].has("value"):
																				pref_effects[key][p_val_idx][1].erase("value")
																	else:
																		pref_effects[key][p_val_idx][1]["action"] = "advance"
																"remove":
																	pref_effects[key].remove(p_val_idx)
														_:
															#l_val[1][param] = cur_v[1][param]
															pref_effects[key][p_val_idx][1][param] = cur_v[1][param]
												added = true
												break
										if not added:
											#var new_id = pref_effects[key].keys().size()
											#pref_effects[key][new_id] = cur_v
											pref_effects[key].append(cur_v)
									else:
										# if previous effect NOT have vfx record
										pref_effects[key] = []
										#pref_effects[key][0] = cur_v
										pref_effects[key].append(cur_v)
							if pref_effects.has("vfx"):
								if pref_effects["vfx"].empty():
									pref_effects.erase("vfx")
								else:
									print("Loaded vfx value -> %s" %pref_effects["vfx"])
						"portrait":
							#print(">> Portrait for id %s -> %s" %[i,current_effects[key]])
							var converted_val = convert_effect_dic(current_effects[key])
							if not pref_effects.has(key):
								#if prev effect dont have portrait directly assign for it
								
								# remove all anim param
								for p_id in converted_val.keys():
									#every portrait id
									if typeof(converted_val[p_id][1]) == TYPE_DICTIONARY:
										if converted_val[p_id][1].has("anim"):
											converted_val[p_id][1].erase("anim")
									if converted_val[p_id][1].empty():
										converted_val.erase(p_id)
								
								if not converted_val.empty():
									pref_effects[key] = converted_val
							else:
								#already have portrait effects
								for p_id in converted_val.keys():
									if pref_effects[key].has(p_id):
										match typeof(converted_val[p_id][1]):
											TYPE_NIL:
												pref_effects[key].erase(p_id)
											TYPE_DICTIONARY:
												for param_id in converted_val[p_id][1].keys():
													if param_id != "anim":
														pref_effects[key][p_id][1][param_id] = converted_val[p_id][1][param_id]
									else:
										pref_effects[key][p_id] = converted_val[p_id]
						_:
							pref_effects[key] = current_effects[key]
		c_dialog_id += 1
		if not Func.is_inside_range(c_dialog_id,lookup_range[lookup_index]):
			lookup_index += 1
			if lookup_index >= lookup_range.size():
				break
			else:
				c_dialog_id = int(lookup_range[lookup_index].x)
		if not Func.is_inside_range(c_dialog_id,ch_range):
			ch_id = get_chapter_id(c_dialog_id)
			ch_range = get_chapter_range(ch_id)
	
	return pref_effects

func add_log_name(log_data):
	var updated_log_data = log_data
	
	if updated_log_data.empty():
		return updated_log_data
	
	var current_chapter = get_chapter_id(updated_log_data[0]["id"])
	var chapter_range = get_chapter_range(current_chapter)
	
	for d_log in updated_log_data:
		var c_id = d_log["id"]
		if not Func.is_inside_range(c_id,chapter_range):
			current_chapter = get_chapter_id(c_id)
			chapter_range = ChapterData.data[current_chapter]["range"]
		var e_id = c_id - int(chapter_range.x)
		if DialogData[current_chapter].data.has(e_id):
			if DialogData[current_chapter].data[e_id].has("actor"):
				var actor_id = DialogData[current_chapter].data[e_id]["actor"]
				var actor_name = ""
				#var actor_name = Characters[actor_id].data["name"]
				if DialogData[current_chapter].data[e_id].has("effects"):
					if DialogData[current_chapter].data[e_id]["effects"].has("name"):
						actor_name = DialogData[current_chapter].data[e_id]["effects"]["name"]
				d_log["a_id"] = actor_id
				d_log["name"] = actor_name
		var voice_res = Func.get_voice(current_chapter, c_id)
		if voice_res != null:
			d_log["voice"] = voice_res
	
	return updated_log_data

func get_char_id(chapter_id,dialog_id):
	var CDialog = DialogData[chapter_id]
	var c_d_id = get_chapter_dialog_id(chapter_id,dialog_id)
	if CDialog.data.has(c_d_id):
		#print("CDialog -> %s" %var2str(CDialog.data[SaveData.data.dialog]))
		if CDialog.data[c_d_id].has("actor"):
			var char_id = CDialog.data[c_d_id]["actor"]
			return char_id
	return 0

func get_effects(chapter_id,dialog_id):
	var effects = {}
	var CDialog = DialogData[chapter_id]
	var c_d_id = get_chapter_dialog_id(chapter_id,dialog_id)
	if CDialog.data.has(c_d_id):
		if CDialog.data[c_d_id].has("effects"):
			print("Effect found")
			effects = CDialog.data[c_d_id]["effects"]
	return effects

func get_chapter_range(chapter_id) -> Vector2:
	if ChapterData.data.has(chapter_id):
		return ChapterData.data[chapter_id]["range"]
	return Vector2.ZERO

func get_chapter_id(dialog_id) -> int:
	for key in ChapterData.data.keys():
		var dialog_range = ChapterData.data[key]["range"]
		#if d_id >= dialog_range.x and d_id <= dialog_range.y:
		if Func.is_inside_range(float(dialog_id),dialog_range):
			return int(key)
	return -1

func get_chapter_dialog_id(chapter,dialog_id) -> int:
	var c_start_id = int(ChapterData.data[chapter]["range"].x)
	var chapter_dialog_id:int = dialog_id - c_start_id
	return chapter_dialog_id

func is_vfx_onetime(value):
	if OneTimeEffects.has(value):
		return true
	return false

func convert_effect_dic(value, unique = false) -> Dictionary:
	var converted_val = {}
	match typeof(value):
		TYPE_INT:
			converted_val[value] = [value,{}]
		TYPE_ARRAY:
			if unique:
				converted_val[0] = value
			else:
				converted_val[value[0]] = value
		TYPE_DICTIONARY:
			for id_key in value.keys():
				var conv_val = value[id_key]
				if typeof(conv_val) == TYPE_INT:
					conv_val = [conv_val, {}]
				if unique:
					converted_val[id_key] = conv_val
				else:
					converted_val[conv_val[0]] = conv_val
	return converted_val
