extends WindowControl

export(NodePath) var CreditListPath
export(float) var showing_time = 5

onready var CreditParent = get_node(CreditListPath)
onready var ShowTimer = $ShowTimer

var current = -1

var Animations = []

signal started
signal ended

# Called when the node enters the scene tree for the first time.
func _ready():
	for i in (CreditParent.get_child_count()):
		Animations.append(CreditParent.get_child(i).get_node("Anim"))
	#next()

func next(anim = ""):
	current += 1
	if current == 0:
		emit_signal("started")
	elif current == Animations.size():
		current = -1
		emit_signal("ended")
		return
	print("Start showing %s" %current)
	start_show()

func start_show():
	Animations[current].play("show")
	(Animations[current] as AnimationPlayer).connect("animation_finished",self,"showing",[],CONNECT_ONESHOT)

func showing(anim):
	ShowTimer.start(showing_time)
	ShowTimer.connect("timeout",self,"start_hide",[],CONNECT_ONESHOT)

func start_hide():
	Animations[current].play("hide")
	(Animations[current] as AnimationPlayer).connect("animation_finished",self,"next",[],CONNECT_ONESHOT)

func skip():
	if ShowTimer.time_left != 0:
		ShowTimer.stop()
		ShowTimer.emit_signal("timeout")
