extends Node

class_name Func

static func is_inside_range(value:float,vrange:Vector2):
	if value >= vrange.x and value <= vrange.y:
		return true
	return false

static func get_voice(chapter,dialog):
	#print("check voice chapter %s dialog %s" %[chapter,dialog])
	var voice_path = "res://Audio/Voice/en/c%s/d_%s.ogg" %[chapter,dialog]
	if ResourceLoader.exists(voice_path):
		return load(voice_path)
	return null

static func get_voice_length(chapter,dialog):
	var voice_res = get_voice(chapter,dialog)
	if voice_res != null:
		return (voice_res as AudioStream).get_length()
	return null

static func set_audio_volume(bus,value):
	#var vol_db = -80.0 if value == 0 else linear2db(value)
	var bus_id = AudioServer.get_bus_index(bus)
	AudioServer.set_bus_volume_db(bus_id,linear2db(value))
	AudioServer.set_bus_mute(bus_id,true if value == 0 else false)

static func get_reference_size() -> Vector2:
	var screen_width = ProjectSettings.get_setting("display/window/size/width")
	var screen_height = ProjectSettings.get_setting("display/window/size/height")
	return Vector2(screen_width,screen_height)

static func get_cg_gallery_grid_size() -> Vector2:
	return ProjectSettings.get_setting("vn/settings/gallery/cg_grid")

static func get_save_slot_grid_size() -> Vector2:
	return ProjectSettings.get_setting("vn/settings/data_slot/data_grid")

static func get_save_slot_page_count() -> int:
	return ProjectSettings.get_setting("vn/settings/data_slot/page_count")

static func get_dialog_log_max_count() -> int:
	return ProjectSettings.get_setting("vn/settings/dialog_log/max_count")

static func get_dialog_log_visible_count() -> int:
	return ProjectSettings.get_setting("vn/settings/dialog_log/visible_count")

static func get_dialog_log_default_separation() -> float:
	return ProjectSettings.get_setting("vn/settings/dialog_log/default_separation")

static func set_screen_size_override() -> Vector2:
	return ProjectSettings.get_setting("vn/test/display/screen_size_override")

static func get_file_path(file_id) -> String:
	return ProjectSettings.get_setting("vn/files/%s/path" %file_id)

static func get_file_pepper(file_id) -> String:
	return ProjectSettings.get_setting("vn/files/%s/pepper" %file_id)

static func cycle(value,addition,min_value,max_value) -> float:
	var ret_val = value
	ret_val += addition
	if ret_val > max_value:
		ret_val = (min_value - 1) + (ret_val - max_value)
	if ret_val < min_value:
		ret_val = (max_value + 1) - (min_value - ret_val)
	return float(ret_val)
