extends WindowControl

class_name DialogBox

var opened = true
var disable_toggle = false

signal displayed(state)

var prev_focus = null

func _ready():
	leaving = false

func open():
	print("xxx Dialog Box Opened")
	opened = true
	.open()

func leave():
	print("xxx Dialog Box Leaved")
	set_process_input(false)
	opened = false
	.leave()

func revisit(RecoverNode = null):
	print("xxx Dialog Box Revisited")
	opened = true
	set_process_input(true)
	.revisit(RecoverNode)

func close():
	print("xxx Dialog Box Closed")
	opened = false
	.close()
	set_process_input(true)

func _input(event):
	if event is InputEventMouseButton and event.button_index == BUTTON_RIGHT and event.pressed:
		toggle()

func toggle():
	print("xxx Dialog Box Toggled")
	if get_window_anim().is_playing():
		return
	print("Opened value -> %s" %opened)
	if opened:
		emit_signal("displayed",true)
		prev_focus = get_item_parent().get_focus_owner()
		if prev_focus != null:
			prev_focus.release_focus()
		close()
		get_tree().call_group_flags(get_tree().GROUP_CALL_REALTIME,"VNMain","set_normal_mode")
		#print("Focus now is %s" %get_item_parent().get_focus_owner())
	else:
		if prev_focus != null:
			prev_focus.grab_focus()
		open()
		emit_signal("displayed",false)
	
