extends WindowControl

export(PackedScene) var DialogLogItem

var LastItem

var current_id = -1
var dialog_ids = []

signal loaded

func open():
	.open()
	focus_last_item()

func close():
	.close()
	get_tree().call_group("LogVoice","stop")

func focus_last_item():
	var LItem = get_item_parent().get_children().back().get_node_or_null("Button")
	if LItem == null:
		return
	#var Scroller:ScrollContainer = get_item_parent().get_parent()
	yield(get_tree(),"idle_frame")
	yield(get_tree(),"idle_frame")
	LItem.grab_focus()

func init_dialog_log(datas):
	#print("++ Init dialog log data -> %s" %var2str(datas))
	LastItem = null
	current_id = -1
	dialog_ids.empty()
	dialog_ids.resize(datas.size())
	datas.invert()
	for i in datas.size():
		if datas[i] != null:
			dialog_ids[i] = datas[i]["id"]
	
	var ItemLister:VBoxContainer = get_item_parent()
	var Scroller:ScrollContainer = ItemLister.get_parent()
	var item_count = Func.get_dialog_log_max_count()
	var item_visible = Func.get_dialog_log_visible_count()
	var separation = Func.get_dialog_log_default_separation()
	var y_size = Scroller.rect_size.y
	y_size -= float(item_visible - 1) * separation
	var item_y = float(int(y_size / item_visible))
	var diff = y_size - (item_y * item_visible)
	if diff >= float(item_visible - 1):
		separation += 1
	ItemLister.set("custom_constants/separation", separation)
	
	for LogItem in ItemLister.get_children():
		LogItem.free()
	
	for i in range(item_count):
		var NewLogItem
		if ItemLister.has_node("Log%s" %i):
			NewLogItem = ItemLister.get_node("Log%s" %i)
		else:
			NewLogItem = DialogLogItem.instance()
			NewLogItem.name = "Log%s" %i
			NewLogItem.rect_min_size = Vector2(0,item_y)
			NewLogItem.get_node("Button").connect("pressed",self,"log_pressed",[NewLogItem])
			ItemLister.add_child(NewLogItem)
		LastItem = NewLogItem
		NewLogItem.set_item_dic(datas[i])
#		if datas[i] == null:
#			NewLogItem.hide()
#		else:
#			NewLogItem.set_item_dic()
	
	LastItem.set_current(true)

func add_dialog(data):
	#print(">> Add dialog -> %s" %data["dialog"])
	if get_item_parent().get_child_count() > 0:
		var ThisItem:Control = get_item_parent().get_child(0)
		for i in get_item_parent().get_child_count():
			var ItemI = get_item_parent().get_child(i)
			if ItemI.visible:
				break
			ThisItem = ItemI
		get_item_parent().get_children().back().set_current(false)
		dialog_ids.append(data["id"])
		dialog_ids.pop_front()
		ThisItem.raise()
		ThisItem.set_item_dic(data)
		ThisItem.set_current(true)

func log_pressed(NodeObj):
	Audio.play_sfx("ui_accept")
	$Margin/Panel/BackPar/Back.disabled = true
	Confirmation.connect("answered",self,"load_log",[NodeObj],CONNECT_ONESHOT)
	Confirmation.open("conf_log")

func load_log(answer,NodeObj):
	#Confirmation.disconnect("answered",self,"load_log")
	#call("show")
	if answer:
		#print("Loading log %s, data -> %s" %[NodeObj.get_index(),NodeObj.data])
		VNData.load_data(NodeObj.data)
		emit_signal("loaded")
		close()
	$Margin/Panel/BackPar/Back.disabled = false
