extends Control

export(Color) var normal_color
export(Color) var current_color

onready var VoiceBtn = $Top/Voice/VoiceBtn
onready var LoadButton = $Button
onready var DialogLabel = $DialogMargin/DialogPanel/Margin/Dialog
onready var NameLabel = $Top/NamePanel/Name

var data = null

func set_item_dic(dic):
	data = dic
	if dic == null:
		hide()
		return
	if dic.has("dialog"):
		show()
		var actor = null
		var dialog = null
		var voice = null
		var color = null
		dialog = dic["dialog"]
		if dic.has("name"):
			actor = dic["name"]
		if dic.has("voice"):
			voice = dic["voice"]
		if dic.has("color"):
			color = dic["color"]
		set_item(actor,color,dialog,voice)

func set_item(actor,color,dialog,voice):
	set_actor(actor,color)
	set_dialog(dialog)
	set_voice(voice)

func set_actor(aname,color):
	#NameLabel.get_parent().get_parent().modulate = ColorN("white",0) if aname == null else ColorN("white",1)
	NameLabel.get_parent().get_parent().modulate = ColorN("white",0) if aname == null else color
	#NameLabel.get_parent().get_parent().modulate = color
	if aname != null:
		#NameLabel.text = aname
		NameLabel.set_text(aname)

func set_dialog(dialog):
	#DialogLabel.text = dialog
	DialogLabel.set_text(dialog)

func set_voice(stream):
	VoiceBtn.get_parent().visible = false if stream == null else true
	#VoiceBtn.get_child(0).stream = stream
	VoiceBtn.get_node("VoicePlayer").stream = stream

func set_current(state):
	#if LoadButton.visible != state:
	if LoadButton.disabled == state:
		return
	
	if data != null:
		#var m_color = data["color"]
		var m_color = Color.transparent if not data.has("color") else data["color"]
		if m_color != Color.transparent:
			if state:
				m_color = Color.white
		NameLabel.get_parent().get_parent().modulate = m_color
	DialogLabel.set("custom_colors/font_color", current_color if state else normal_color)
	NameLabel.set("custom_colors/font_color", current_color if state else normal_color)
	#LoadButton.visible = !state
	LoadButton.disabled = state
