extends WindowControl

export(PackedScene) var ChoiceItemObj

signal selected(index)

func choice_open(choice_index):
	populate_choice(choice_index)
	.open()

func populate_choice(choice_index):
	for Item in get_item_parent().get_children():
		Item.free()
	var choice_texts = PoolStringArray([])
	var c_text = "choice_%s_%s"
	var c_id = 0
	var current_text = c_text %[choice_index,c_id]
	while(tr(current_text) != current_text):
		choice_texts.append(current_text)
		c_id += 1
		current_text = c_text %[choice_index,c_id]
	c_id = 0
	for choice in choice_texts:
		var NewChoiceObj = ChoiceItemObj.instance()
		NewChoiceObj.name = "Choice%s" %c_id
		NewChoiceObj.text = choice
		NewChoiceObj.connect("pressed",self,"select",[c_id],CONNECT_ONESHOT)
		get_item_parent().add_child(NewChoiceObj)
		c_id += 1
	
	for i in range(choice_texts.size()):
		var prev = i - 1
		var next = i + 1
		if i == 0:
			prev = choice_texts.size() - 1
			get_item_parent().focus_neighbour_bottom = get_item_parent().get_path_to(get_item_parent().get_child(i))
		if i == choice_texts.size() - 1:
			next = 0
			get_item_parent().focus_neighbour_top = get_item_parent().get_path_to(get_item_parent().get_child(i))
		var CurrentChoice = get_item_parent().get_child(i)
		CurrentChoice.focus_neighbour_top = CurrentChoice.get_path_to(get_item_parent().get_child(prev))
		CurrentChoice.focus_neighbour_bottom = CurrentChoice.get_path_to(get_item_parent().get_child(next))
	
	print(choice_texts)

func select(index):
	print("Choice %s selected!" %index)
	emit_signal("selected",index)
	close()
