extends Label

class_name LabelGlowed

#export(PoolColorArray) var color_grade
#export(PoolIntArray) var outline_grade
export(Resource) var glow_data
export(NodePath) var glow_parent

var Glows = []

signal text_changed(text)

# Called when the node enters the scene tree for the first time.
func _ready():
	if glow_data != null:
		var selfFont:DynamicFont = get("custom_fonts/font")
		selfFont.outline_size = glow_data.data["outline_grade"][0]
		set("custom_colors/font_outline_modulate",glow_data.data["color_grade"][0])
		for i in range(glow_data.data["color_grade"].size() - 1):
			var newFont:DynamicFont = selfFont.duplicate()
			var newLabel:Label = Label.new()
			var glowParent = self if glow_parent.is_empty() else get_node(glow_parent)
			newFont.outline_size = glow_data.data["outline_grade"][i+1]
			newLabel.set_anchors_preset(Control.PRESET_WIDE)
			newLabel.text = text
			newLabel.align = align
			newLabel.valign = valign
			#NEW
			newLabel.autowrap = autowrap
			#--->
			newLabel.show_behind_parent = true
			newLabel.set("custom_fonts/font",newFont)
			newLabel.set("custom_colors/font_color",Color.transparent)
			newLabel.set("custom_colors/font_outline_modulate",glow_data.data["color_grade"][i+1])
			glowParent.add_child(newLabel)
			connect("text_changed",newLabel,"set_text")
			Glows.append(newLabel)

func set_text(value):
	emit_signal("text_changed",value)
	.set_text(value)
