extends WindowControl

export(PackedScene) var LangIns
export(String) var next_screen

# Called when the node enters the scene tree for the first time.
func _ready():
	if Options.new_settings:
		open()
		init_languages()
	else:
		#proceed()
		call_deferred("proceed")

func init_languages():
	var default_lang = Options.lang_codes[0]
	var system_lang = OS.get_locale()
	if Options.lang_codes.has(system_lang):
		if default_lang != system_lang:
			default_lang = system_lang
	var LangOptionParent = get_item_parent()
	#var FirstOption
	for i in range(Options.lang_codes.size()):
		var NewOption = LangIns.instance()
		#if i == 0:
		#	FirstOption = NewOption
		#if i == Options.lang_codes.size() - 1:
		#	if i != 0:
		#		
		#		pass
		NewOption.text = Options.lang_names[i]
		NewOption.connect("focus_entered",self,"change_lang",[i])
		#NewOption.connect("pressed",self,"leave")
		NewOption.connect("pressed",self,"proceed")
		LangOptionParent.add_child(NewOption)
	LangOptionParent.get_child(Options.lang_codes.find(default_lang)).grab_focus()

func change_lang(lang_id):
	Options.set_option("language",lang_id)
	Options.update_lang_ui()

func proceed():
	#Options.save_settings()
	Scene.go_to(next_screen)
