extends WindowControl

export(PackedScene) var ItemObj
export(NodePath) var MusicPlayerPath
export(NodePath) var ScrollerPath

onready var MusicPlayer:AudioStreamPlayer = get_node_or_null(MusicPlayerPath)
onready var Scroller:ScrollContainer = get_node_or_null(ScrollerPath)

var active_state = []

func _ready():
	init_music_items()

func init_music_items():
	if Audio.BGMData.size() > 0:
		#var BackButton = get_item_parent().get_node(get_item_parent().focus_neighbour_bottom)
		var TempInstance = ItemObj.instance() as Control
		active_state = VNData.get_bgm_states()
		if active_state.size() != Audio.BGMData.size():
			active_state.resize(Audio.BGMData.size())
		for i in active_state.size():
			if active_state[i] == null:
				active_state[i] = false
		#print("bgm player active state = %s" %var2str(active_state))
		
		var item_order = []
		var item_state = true
		
		#get_item_parent().columns = Audio.BGMData.size() + 1
		get_item_parent().columns = Audio.BGMData.size()
		
		#item_order.append(false)
		for i in Audio.BGMData.size():
			item_order.append(item_state)
			item_state = !item_state
		
		#item_order.append(false)
		item_state = false
		for i in Audio.BGMData.size():
			item_order.append(item_state)
			item_state = !item_state
		
		var item_id = 0
		var PrevNode = get_item_parent()
		var BackNode = get_item_parent().get_node(get_item_parent().focus_neighbour_bottom)
		
		for i in item_order.size():
			var NewItemObj = null
			
			if item_order[i]:
				NewItemObj = ItemObj.instance() as MusicItem
				NewItemObj.name = "Track%s" %item_id
				NewItemObj.set_audio_player(MusicPlayer)
				NewItemObj.set_id(item_id,active_state[item_id])
				item_id += 2
				if item_id >= Audio.BGMData.size():
					item_id = 1
			else:
				if i == item_order.size() - 1:
					continue
				NewItemObj = Control.new()
				NewItemObj.name = "Empty%s" %i
				NewItemObj.rect_min_size = TempInstance.rect_min_size
				NewItemObj.mouse_filter = Control.MOUSE_FILTER_IGNORE
			
			get_item_parent().add_child(NewItemObj)
		
		for i in Audio.BGMData.size():
			var Current = get_item_parent().get_node("Track%s" %i).get_node("TextureButton") as TextureButton
			PrevNode.focus_neighbour_right = PrevNode.get_path_to(Current)
			Current.focus_neighbour_bottom = Current.get_path_to(BackNode)
			Current.focus_neighbour_left = Current.get_path_to(PrevNode)
			PrevNode = Current
		
		#TempInstance.free()
		var FirstNode = get_item_parent().get_node("Track0").get_node("TextureButton") as TextureButton
		get_item_parent().focus_neighbour_left = get_item_parent().get_path_to(PrevNode)
		FirstNode.focus_neighbour_left = FirstNode.get_path_to(PrevNode)
		PrevNode.focus_neighbour_right = PrevNode.get_path_to(FirstNode)

func reload_gallery():
	var new_as = VNData.get_bgm_states()
	if new_as.size() != Audio.BGMData.size():
		new_as.resize(Audio.BGMData.size())
	for i in new_as.size():
		if new_as[i] == null:
			new_as[i] = false
		if new_as[i] != active_state[i]:
			var CTrackNode = get_item_parent().get_node("Track%s" %i)
			CTrackNode.set_active_state(new_as[i])
			CTrackNode.update_visual()
			active_state[i] = new_as[i]

func open():
	reload_gallery()
	Scroller.scroll_horizontal = 0
	.open()
	Audio.pause_bgm()

func close():
	#get_music_player().stop()
	get_tree().call_group("MusicItem","stop")
	MusicPlayer.stop()
	.close()
	Audio.resume_bgm()
