extends Node

class_name NodeReference

export(String) var node_name = ""

var NodeRef
var yield_ans
var yield_signalname

signal answer_matched
signal answer_not_matched

# Called when the node enters the scene tree for the first time.
func _ready():
	#print("Object %s has signal %s ? %s" %[name,"answer_matched", has_user_signal("answer_matched")])
	match node_name:
		"[tree]":
			NodeRef = get_tree()
		_:
			NodeRef = get_node_or_null("/root/%s" %node_name)
		

func call_func(func_name, func_args = null):
	#print("Calling func")
	if func_args == null:
		NodeRef.call(func_name)
	else:
		var args_arr = []
		args_arr.append(func_args)
		NodeRef.callv(func_name, args_arr)

func yield_signal(signal_name,answer = null):
	if not NodeRef.is_connected(signal_name,self,"reff_connection"):
		NodeRef.connect(signal_name,self,"reff_connection",[],CONNECT_ONESHOT)
	yield_ans = answer
	yield_signalname = signal_name

func reff_connection(answer = null):
	yield(get_tree(),"idle_frame")
	#NodeRef.disconnect(yield_signalname,self,"reff_connection")
	if answer == yield_ans:
		emit_signal("answer_matched")
	else:
		emit_signal("answer_not_matched")
