extends Control

class_name OptionItem

export(NodePath) var LabelPath
export(NodePath) var SetterPath
export(String) var select_sfx
export(String) var change_sfx

signal selected
signal deselected
signal changed

var SetterObject

var current_value = null
var selected = false

func _ready():
	var LabelObj = get_node_or_null(LabelPath)
	if LabelObj:
		#LabelObj.text = name
		LabelObj.set_text(name)
	connect("selected",Audio,"play_sfx",[select_sfx])
	connect("changed",Audio,"play_sfx",[change_sfx])

func set_value(value):
	get_setter_object().value = value

func get_setter_object():
	if SetterObject == null:
		SetterObject = get_node_or_null(SetterPath)
	return SetterObject

func set_setting(value):
	if current_value != null:
		emit_signal("changed")
	current_value = value
	print("value %s changed -> %s" %[name,value])
	Options.set_option(name,value)

func set_active(state):
	if state == selected:
		return
	if state:
		emit_signal("selected")
	else:
		emit_signal("deselected")
	selected = state
