extends Node

class_name PropertyCopier

export(NodePath) var copy_node_path
export(NodePath) var paste_node_path
export(String) var copy_property = ""
export(String) var paste_property = ""

onready var CopyNode = get_node(copy_node_path)
onready var PasteNode = get_node_or_null(paste_node_path)

# Called when the node enters the scene tree for the first time.
func _ready():
	if CopyNode == null or copy_property == "":
		return
	CopyNode.connect("ready",self,"copying_property",[],CONNECT_ONESHOT)

func copying_property():
	var TargetNode = self if PasteNode == null else PasteNode
	var target_property = copy_property if paste_property == "" else paste_property
	var copy_value = CopyNode.get(copy_property)
	#TargetNode.set(target_property,copy_value)
	#print("Copy text %s to %s" %[copy_value,TargetNode.name])
	TargetNode.call("set_%s" %target_property,copy_value)

# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass
