extends Object

class_name ScaledBlur

var thread

signal blur_finished(image)

func blur_image_threaded(img:Image,shrink_times,loop_times:int,interpolation:int = 1):
	thread = Thread.new()
	if thread.is_active():
		return
	thread.start(self,"_blur_image_th", [img, shrink_times, loop_times, interpolation])

func _blur_image_th(data) -> Image:
	data[0] = blur_image(data[0],data[1],data[2],data[3])
	call_deferred("threaded_blur_done")
	return data[0]

func threaded_blur_done():
	var blured_img = thread.wait_to_finish()
	emit_signal("blur_finished",blured_img)

func blur_image(img:Image,shrink_times,loop_times:int,interpolation:int = 1) -> Image:
	#var t1 = OS.get_ticks_msec()
	var true_size = img.get_size()
	for i in loop_times:
		match typeof(shrink_times):
			TYPE_INT:
				shrink_times = int(shrink_times)
				for j in shrink_times:
					img.shrink_x2()
			TYPE_REAL:
				var resized = true_size * float(shrink_times)
				img.resize(int(resized.x),int(resized.y),interpolation)
		img.resize(int(true_size.x),int(true_size.y),interpolation)
	#var t2 = OS.get_ticks_msec()
	#print("Scaled blur takes %s sec" %((t2-t1) / 1000.0))
	return img
