extends Node

func _input(event):
	if event.is_action_pressed("screen_capture"):
		take_screenshot()
	if event.is_action_pressed("user_folder"):
		open_user_folder()

func take_screenshot():
	var NewImage:Image = get_tree().root.get_texture().get_data()
	NewImage.flip_y()
	
	var user_folder = OS.get_user_data_dir()
	var file_name = "screencapture_{day}-{month}-{year}_{hour}-{minute}-{second}.png".format(OS.get_datetime())
	var full_path = user_folder.plus_file("screen_capture")
	
	var Dir = Directory.new()
	if not Dir.dir_exists(full_path):
		Dir.make_dir_recursive(full_path)
	
	full_path = full_path.plus_file(file_name)
	print("Screen Capture saved at %s" %full_path)
	NewImage.save_png(full_path)
	

func open_user_folder():
	OS.shell_open(OS.get_user_data_dir())
