extends ScrollContainer

class_name ScrollContainerExtended

export(NodePath) var VScrollOverride
export(bool) var VRemove = true
export(NodePath) var HScrollOverride
export(bool) var HRemove = true

onready var OVScroll = get_node_or_null(VScrollOverride)
onready var OHScroll = get_node_or_null(HScrollOverride)

# Called when the node enters the scene tree for the first time.
func _ready():
	init_scrollbar()

func init_scrollbar():
	if OVScroll != null:
		var CVScroll = get_v_scrollbar()
		CVScroll.set("custom_styles/grabber_highlight", OVScroll.get("custom_styles/grabber_highlight"))
		CVScroll.set("custom_styles/grabber", OVScroll.get("custom_styles/grabber"))
		CVScroll.set("custom_styles/scroll_focus", OVScroll.get("custom_styles/scroll_focus"))
		CVScroll.set("custom_styles/scroll", OVScroll.get("custom_styles/scroll"))
		CVScroll.set("custom_styles/grabber_pressed", OVScroll.get("custom_styles/grabber_pressed"))
		remove_child(CVScroll)
		#OVScroll.get_parent().add_child_below_node(OVScroll,CVScroll)
		OVScroll.get_parent().call_deferred("add_child_below_node",OVScroll,CVScroll)
		CVScroll.size_flags_horizontal = SIZE_SHRINK_END
		if VRemove:
			OVScroll.queue_free()
	if OHScroll != null:
		var CHScroll = get_h_scrollbar()
		CHScroll.set("custom_styles/grabber_highlight", OHScroll.get("custom_styles/grabber_highlight"))
		CHScroll.set("custom_styles/grabber", OHScroll.get("custom_styles/grabber"))
		CHScroll.set("custom_styles/scroll_focus", OHScroll.get("custom_styles/scroll_focus"))
		CHScroll.set("custom_styles/scroll", OHScroll.get("custom_styles/scroll"))
		CHScroll.set("custom_styles/grabber_pressed", OHScroll.get("custom_styles/grabber_pressed"))
		remove_child(CHScroll)
		#OVScroll.get_parent().add_child_below_node(OVScroll,CVScroll)
		OHScroll.get_parent().call_deferred("add_child_below_node",OHScroll,CHScroll)
		CHScroll.size_flags_vertical = SIZE_SHRINK_END
		if VRemove:
			OHScroll.queue_free()
