extends Node2D

class_name VNCG

export(NodePath) var StateTreePath

onready var CGTweener = $Tween

var StateTree:AnimationTree
var Transition:AnimationNodeTransition
var state = 0
var removed = false

signal ended

func enter():
	if removed:
		return
	CGTweener.interpolate_property(self,"modulate",Color.transparent,Color.white,0.5,Tween.TRANS_LINEAR,Tween.EASE_IN)
	CGTweener.start()

func advance(skip = false):
	if removed:
		return
	if get_state_tree() != null:
		if typeof(skip) == TYPE_BOOL:
			# skip = true, default = false
			state += 1
		else:
			# load -> Integer
			state = skip
		
		if state < Transition.input_count:
			StateTree.set("parameters/Transition/current",state)
		else:
			emit_signal("ended")
	else:
		emit_signal("ended")

func remove(skip = false):
	removed = true
	if skip:
		queue_free()
	else:
		CGTweener.interpolate_property(self,"modulate",Color.white,Color.transparent,0.5,Tween.TRANS_LINEAR,Tween.EASE_IN)
		CGTweener.interpolate_callback(self,0.5,"queue_free")
		CGTweener.start()

func get_state_tree():
	if StateTree == null:
		StateTree = get_node_or_null(StateTreePath)
		if StateTree != null:
			Transition = StateTree.tree_root.get_node("Transition")
	return StateTree
