extends VNEffect

class_name VNProps

export(NodePath) var AnimNodePath
export(NodePath) var TweenerNodePath

var AnimNode:AnimationTree setget ,get_anim_node
var Tweener:Tween setget ,get_tweener_node
var state = 0

func enter():
	get_tweener_node().interpolate_property(self,"modulate",Color.transparent,Color.white,0.3)
	get_tweener_node().start()

func set_action(value = null):
	print("Value is %s" %value)
	if typeof(value) == TYPE_ARRAY:
		callv(value[0],value[1])
	else:
		call(value)

func remove():
	print("Removing props")
	get_tweener_node().interpolate_property(self,"modulate",Color.white,Color.transparent,0.3)
	get_tweener_node().interpolate_callback(self,0.3,"queue_free")
	get_tweener_node().start()

func advance(value = 1):
	state += value
	print("Advancing props to state %s" %state)
	get_anim_node().set("parameters/Transition/current",state)

func get_anim_node() -> AnimationTree:
	if AnimNode == null:
		AnimNode = get_node(AnimNodePath)
	return AnimNode

func get_tweener_node() -> Tween:
	if Tweener == null:
		Tweener = get_node(TweenerNodePath)
	return Tweener
