extends Node

class_name WindowControl

export(NodePath) var ItemParentPath
export(NodePath) var WindowAnimPath
export(bool) var recover_focus = true

var ItemParent:Control
var CallerNode:Control
var WindowAnim:AnimationPlayer
#var ClosingTimer:Timer

signal window_opened
signal window_closed

var leaving = true

func open():
	print("Opening window %s" %name)
	#get_tree().call_group("Voice","stop")
	get_tree().call_group("Voice","set_stream_paused",true)
	get_tree().call_group("DialogTimer","set_paused",true)
	
	CallerNode = get_item_parent().get_focus_owner()
	revisit()
	if CallerNode != null:
		print("Caller Node of %s is %s" %[name,CallerNode.name])
	if get_item_parent().focus_mode != Control.FOCUS_NONE:
		get_item_parent().grab_focus()

#func set_close_delay(close_delay = 0):
#	if close_delay > 0:
#		create_closing_timer()
#		ClosingTimer.wait_time = close_delay
#		ClosingTimer.start()

func revisit(RecoverNode = null):
	if RecoverNode != null and recover_focus:
		RecoverNode.grab_focus()
	if leaving:
		print("Revisit %s" %name)
		get_window_anim().play("open")
		yield(get_window_anim(),"animation_finished")
	leaving = false
	emit_signal("window_opened")

func leave():
	leaving = true
	emit_signal("window_closed")
	#call_deferred("emit_signal","window_closed")
	get_window_anim().play("close")

func close():
#	if ClosingTimer != null:
#		if ClosingTimer.time_left > 0:
#			return
#
	if leaving:
		return
	print("Window close on %s" %name)
	leave()
	#print("Current animation is -> %s" %get_window_anim().current_animation)
	yield(get_window_anim(),"animation_finished")
	
	get_tree().call_group("Voice","set_stream_paused",false)
	get_tree().call_group("DialogTimer","set_paused",false)
	
	
	if CallerNode == null:
		return
	print(" > CallerNode for %s is %s" %[name, CallerNode.name])
	#var CallerWindow = CallerNode.get_parent()
	var CallerWindow = CallerNode
	#print("%s is %s" %[CallerWindow.name,CallerWindow.get_class()])
	while not (CallerWindow.is_class("WindowControl") or CallerWindow.get_class() == "WindowControl"):
		#print("%s is a window control" %CallerWindow.name)
		CallerWindow = CallerWindow.get_parent()
		if CallerWindow == null:
			print("Caller window cannot found!")
			return
	#CallerNode.grab_focus()
	if CallerWindow == self:
		return
	CallerWindow.revisit(CallerNode)
	
	#CallerWindow.call_deferred("revisit",CallerNode)
	

func get_item_parent() -> Control:
	if ItemParent == null:
		ItemParent = get_node_or_null(ItemParentPath)
	return ItemParent

func get_window_anim() -> AnimationPlayer:
	if WindowAnim == null:
		WindowAnim = get_node_or_null(WindowAnimPath)
	return WindowAnim

#func create_closing_timer():
#	ClosingTimer = Timer.new()
#	ClosingTimer.name = "ClosingTimer"
#	add_child(ClosingTimer)
#	ClosingTimer.one_shot = true
#	ClosingTimer.autostart = false

func is_class(type):
	return type == "WindowControl" or .is_class(type)

func get_type():
	return "WindowControl"
